#ifndef __ISR2_IOFUNCS
#define __ISR2_IOFUNCS

#include "IOFuncs.H"
#include <sstream>
#include <string>
using namespace std;


// ==================================================================

string 
ParseString(string &strLine, const char cSeperator=' '){
  size_t tPos, tLen;
  string strWord;

  // DOS to UNIX
  tPos=strLine.find_last_of((char) 13);
  if (tPos!=string::npos){
    strLine.erase(tPos,1);
  }

  // Find first character that is not a seperator
  tPos=strLine.find_first_not_of(cSeperator);

  // Found one?
  if (tPos!=string::npos){
    // Remove them
    tLen=strLine.length();
    strLine=strLine.substr(tPos,tLen-tPos);

    // Get new length of string
    tLen=strLine.length();
  
    // Are there characters left?
    if (tLen>0){
      // Find next seperator
      tPos=strLine.find_first_of(cSeperator);

      // Found one?
      if (tPos!=string::npos){
	// Get substring and remove it from line
	strWord=strLine.substr(0,tPos);
	strLine=strLine.substr(tPos+1,tLen-tPos-1);
      }else{
	// The whole line is a word
	strWord=strLine;
	strLine="";
      }
    }else{
      // empty line
      strWord="";
      strLine="";
    }
  }else{
    // empty line
    strWord="";
    strLine="";    
  }

  return strWord;
}


string 
LowerCase(const string &strWord){
  size_t tPos;
  string strLower=strWord;

  // Loop over all character in string
  for (tPos=0; tPos<strWord.length(); tPos++){
    // Is character in upper case?
    if (strWord.at(tPos)>='A' && strWord.at(tPos)<='Z'){
      // yup. convert it to lower case and append
      // to temporary string
      strLower.replace(tPos,1,1,'a'+(strWord.at(tPos)-'A'));
    }
  }
  return strLower;
}

// following functions need some error checking

// read a float from a string
double getDouble(string &strLine){
  istringstream istrString(strLine.c_str());
  double dValue;

  istrString >> dValue;
  ParseString(strLine);

  return dValue;
}


#endif












