
#ifndef MOD_IO_H
#define MOD_IO_H

#include "PT/PTM_ParPartCont.h"
#include "ModControl.H"
#include "ModGeometry.H"
#include "PT/PTfstream.h"
#include "PT/PTSResource.h"
#include "PT/PTBinaryIO.h"
#include "PT/PTC_Para.h"
#include "PT/PTstring.h"

typedef PTM_ParPartCont<MDRotParticle,DIM,PTM_PartContLC<MDRotParticle,DIM,double_vec,int_vec> > ParticleBox;

bool
WriteSaveFile(ostream &out, double t, ParticleBox &box, Geometry &geo, 
	      PTS_CommEnv &ce, PTC_Para &pf );
bool
ReadSaveFile(istream &in, double &t, ParticleBox &box, Geometry &geo, 
	      PTC_Para &pf );

int 
ReadRestartFile(istream & restart_in, ParticleBox & box, Geometry & geo,
		Control & control, double & t, int & t_step, 
		PTC_Para &pf);

int 
WriteBallFile(ostream &out, ParticleBox &box);


/** sets the format for binary I/O */
int 
set_binary_format(istream &, PTC_Para &, std::string keyword);

/** sets the format for binary I/O */
int 
set_binary_format(ostream &, PTC_Para &, std::string keyword);

int    
WriteRestartFile(ofstream & out, ParticleBox & box, Geometry & geo,
		 Control & control, double t, int t_step, 
		 PTC_Para &pf );

int
ProgressInfo(ostream &out, ParticleBox & box, 
	     double t, int t_step, PTS_Resource & );

#endif




